/*
Grain Study - Andrew Aaron 30.12.14
*/

autowatch = 1;

inlets = 2;
outlets = 0;

var cutRange = 100;

var buf = new Buffer("study");		//Source buffer.
var polbuf = new Buffer("polter");	//Desination buffer.

var totalSamp = 0;
var maxGrainSize = 0;

var sampRate;
var grainSize;	//Grainsize is global so initial size
 				//can adapt to sample rate. See "setGrainSize".
	
function clearpolter()
{
	var samples = new Array;
	var frames = polbuf.framecount();
	
	for (var i=0; i<frames; i++)
		samples[i] = 0.0;

	polbuf.poke(1, 0, samples);
	polbuf.poke(2, 0, samples);
}

function setMaxGrainSize(x)
{
	maxGrainSize = x * sampRate;
}
	
function samprate(y)
{
	sampRate = y * 0.001;
}

function setGrainSize()
{
	grainSize = samprate * 10;
}

function bang()
{
	var samplesL = new Array;	//Create arrays for the left and right
	var samplesR = new Array;	//output channels.
	
	var frames = buf.framecount();	//Find the total amount of frames
	var channels = buf.channelcount();	//and channels of the source buffer.
	
	var grainPos = 0;		//Grain position within the source buffer.
	
	clearpolter();			//Clear the destination buffer.
							
	if(bang && channels == 2)		//React on bang and if source buffer is 
	{								//2 channels.
			
		grainPos = Math.ceil(Math.random() * frames);
		grainSize = Math.ceil(Math.random() * maxGrainSize) + 441;
		
			//Randomly generate read position to look into the source buffer.
			//Also generation a grain size (+ 441 so at least 10ms long).
		
		var j = 0;		//Indexing variables. 
		var i;
		
		samplesL.slice(0, totalSamp);	//Memory management!
		samplesR.slice(0, totalSamp);	//Clear the arrays holding our samples.
		
		for(i = grainPos; i < (grainPos+grainSize); i++)
		{
			samplesL[j] = buf.peek(1, i);	//peek(channel, index) returns
			samplesR[j] = buf.peek(2, i);	//value.
			
			//Assign a value in our sample array from source buffer.
			//Note that j is zero indexed, whereas i is based on positions
			//in the source buffer. Check the for loop conditions. 
			
			samplesL[j] = samplesL[j] * (Math.sin(((j / grainSize) * Math.PI)))
			samplesR[j] = samplesR[j] * (Math.sin(((j / grainSize) * Math.PI)))
			
			//Simple windowing function uses the first half of a sine wave. 
			//This gives you the phase (Math.sin(((j / grainSize) * Math.PI)))
			//In other words, which part of the sine wave to apply to the 
			//sample currently being processed. 
			
			polbuf.poke(1, j, samplesL[j]);
			polbuf.poke(2, j, samplesR[j]);
			
			//Put the new sample value inside "polter" destination buffer.
			
			j++;	//Increment for the next sample.
			
			totalSamp++;	//Increment for array size so we can clear 
							//next time this grain function is called. 
							//See line 59. 
		}
	} 
}
